﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Core;
using HEAL.Attic;

namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment.Algorithms {
  [StorableType("8AE6AC8A-7F9A-44C7-911A-4E618D1CC928")]
  public interface ISingleObjectiveSolutionScope<TSolution> : IScope {
    TSolution Solution { get; set; }
    double Fitness { get; set; }
  }

  [StorableType("F007BD11-9CF1-418E-A113-BA68EFD0BC73")]
  public interface IContext : IExecutionContext {
    new IExecutionContext Parent { get; set; }
    int Iterations { get; set; }
    int EvaluatedSolutions { get; set; }
    double BestQuality { get; set; }

    event EventHandler BestQualityChanged;
  }

  [StorableType("5723FC2A-39F7-4C7D-88D8-944C347B52D8")]
  public interface IStochasticContext : IContext {
    IRandom Random { get; set; }
  }
}
